import _pt from "prop-types";
import React from 'react';
import getDirection from 'direction';
import DirectionContext from './DirectionContext';
export default function DirectionProvider(_ref) {
  var children = _ref.children,
      dir = _ref.dir,
      inline = _ref.inline,
      value = _ref.value;
  var direction = dir || getDirection(value) || 'neutral';
  var Tag = inline ? 'span' : 'div';
  return React.createElement(DirectionContext.Provider, {
    value: direction
  }, React.createElement(Tag, {
    dir: direction
  }, children));
}
DirectionProvider.propTypes = {
  children: _pt.any.isRequired,
  dir: _pt.any,
  inline: _pt.bool,
  value: _pt.string
};