function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import hoistNonReactStatics from 'hoist-non-react-statics';
import uuid from 'uuid/v4';
import DirectionContext from './DirectionContext';
export default function withStylesFactory(aesthetic) {
  return function withStyles(styleSheet, options) {
    if (options === void 0) {
      options = {};
    }

    var _options = options,
        _options$cxPropName = _options.cxPropName,
        cxPropName = _options$cxPropName === void 0 ? aesthetic.options.cxPropName : _options$cxPropName,
        _options$extendable = _options.extendable,
        extendable = _options$extendable === void 0 ? aesthetic.options.extendable : _options$extendable,
        _options$extendFrom = _options.extendFrom,
        extendFrom = _options$extendFrom === void 0 ? '' : _options$extendFrom,
        _options$passThemePro = _options.passThemeProp,
        passThemeProp = _options$passThemePro === void 0 ? aesthetic.options.passThemeProp : _options$passThemePro,
        _options$pure = _options.pure,
        pure = _options$pure === void 0 ? aesthetic.options.pure : _options$pure,
        _options$stylesPropNa = _options.stylesPropName,
        stylesPropName = _options$stylesPropNa === void 0 ? aesthetic.options.stylesPropName : _options$stylesPropNa,
        _options$themePropNam = _options.themePropName,
        themePropName = _options$themePropNam === void 0 ? aesthetic.options.themePropName : _options$themePropNam;
    return function withStylesComposer(WrappedComponent) {
      var baseName = WrappedComponent.displayName || WrappedComponent.name;
      var styleName = baseName + "-" + uuid();
      var Component = pure ? React.PureComponent : React.Component;
      aesthetic.setStyleSheet(styleName, styleSheet, extendFrom);

      var WithStyles = function (_Component) {
        _inheritsLoose(WithStyles, _Component);

        WithStyles.extendStyles = function extendStyles(customStyleSheet, extendOptions) {
          if (extendOptions === void 0) {
            extendOptions = {};
          }

          if ("production" !== process.env.NODE_ENV) {
            if (!extendable) {
              throw new Error(baseName + " is not extendable.");
            }
          }

          return withStyles(customStyleSheet, _extends({}, options, extendOptions, {
            extendFrom: styleName
          }))(WrappedComponent);
        };

        function WithStyles(props, dir) {
          var _this;

          _this = _Component.call(this, props) || this;

          _defineProperty(_assertThisInitialized(_this), "transformStyles", function () {
            for (var _len = arguments.length, styles = new Array(_len), _key = 0; _key < _len; _key++) {
              styles[_key] = arguments[_key];
            }

            return aesthetic.transformStyles(styles, _this.state.options);
          });

          var opts = {
            name: styleName,
            rtl: aesthetic.isRTL(dir)
          };
          _this.state = {
            dir: dir,
            options: opts,
            styles: aesthetic.createStyleSheet(styleName, opts)
          };
          return _this;
        }

        var _proto = WithStyles.prototype;

        _proto.componentDidMount = function componentDidMount() {
          aesthetic.flushStyles(styleName);
        };

        _proto.componentDidUpdate = function componentDidUpdate() {
          var dir = this.context;

          if (dir !== this.state.dir) {
            var opts = {
              name: styleName,
              rtl: aesthetic.isRTL(dir)
            };
            this.setState({
              dir: dir,
              options: opts,
              styles: aesthetic.createStyleSheet(styleName, opts)
            }, function () {
              aesthetic.flushStyles(styleName);
            });
          }
        };

        _proto.render = function render() {
          var _extraProps;

          var _this$props = this.props,
              wrappedRef = _this$props.wrappedRef,
              props = _objectWithoutPropertiesLoose(_this$props, ["wrappedRef"]);

          var extraProps = (_extraProps = {}, _extraProps[cxPropName] = this.transformStyles, _extraProps[stylesPropName] = this.state.styles, _extraProps.ref = wrappedRef, _extraProps);

          if (passThemeProp) {
            extraProps[themePropName] = aesthetic.getTheme();
          }

          return React.createElement(WrappedComponent, _extends({}, props, extraProps));
        };

        return WithStyles;
      }(Component);

      _defineProperty(WithStyles, "contextType", DirectionContext);

      _defineProperty(WithStyles, "displayName", "withStyles(" + baseName + ")");

      _defineProperty(WithStyles, "styleName", styleName);

      _defineProperty(WithStyles, "WrappedComponent", WrappedComponent);

      hoistNonReactStatics(WithStyles, WrappedComponent);
      return WithStyles;
    };
  };
}