function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import hoistNonReactStatics from 'hoist-non-react-statics';
export default function withThemeFactory(aesthetic) {
  return function withTheme(options) {
    if (options === void 0) {
      options = {};
    }

    var _options = options,
        _options$pure = _options.pure,
        pure = _options$pure === void 0 ? aesthetic.options.pure : _options$pure,
        _options$themePropNam = _options.themePropName,
        themePropName = _options$themePropNam === void 0 ? aesthetic.options.themePropName : _options$themePropNam;
    return function withThemeComposer(WrappedComponent) {
      var baseName = WrappedComponent.displayName || WrappedComponent.name;
      var Component = pure ? React.PureComponent : React.Component;

      var WithTheme = function (_Component) {
        _inheritsLoose(WithTheme, _Component);

        function WithTheme() {
          return _Component.apply(this, arguments) || this;
        }

        var _proto = WithTheme.prototype;

        _proto.render = function render() {
          var _extraProps;

          var _this$props = this.props,
              wrappedRef = _this$props.wrappedRef,
              props = _objectWithoutPropertiesLoose(_this$props, ["wrappedRef"]);

          var extraProps = (_extraProps = {}, _extraProps[themePropName] = aesthetic.getTheme(), _extraProps.ref = wrappedRef, _extraProps);
          return React.createElement(WrappedComponent, _extends({}, props, extraProps));
        };

        return WithTheme;
      }(Component);

      _defineProperty(WithTheme, "displayName", "withTheme(" + baseName + ")");

      _defineProperty(WithTheme, "WrappedComponent", WrappedComponent);

      hoistNonReactStatics(WithTheme, WrappedComponent);
      return WithTheme;
    };
  };
}