import React from 'react';
import { Direction } from 'aesthetic';
export interface DirectionProviderProps {
    children: NonNullable<React.ReactNode>;
    dir?: Exclude<Direction, 'neutral'>;
    inline?: boolean;
    value?: string;
}
/**
 * Explicitly define a direction or automatically infer a direction based on a string of text.
 * Will render an element with a `dir` attribute set.
 */
export default function DirectionProvider({ children, dir, inline, value, }: DirectionProviderProps): JSX.Element;
//# sourceMappingURL=DirectionProvider.d.ts.map