"use strict";

exports.__esModule = true;
exports.default = DirectionProvider;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _direction = _interopRequireDefault(require("direction"));

var _DirectionContext = _interopRequireDefault(require("./DirectionContext"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function DirectionProvider(_ref) {
  var children = _ref.children,
      dir = _ref.dir,
      inline = _ref.inline,
      value = _ref.value;
  var direction = dir || (0, _direction.default)(value) || 'neutral';
  var Tag = inline ? 'span' : 'div';
  return _react.default.createElement(_DirectionContext.default.Provider, {
    value: direction
  }, _react.default.createElement(Tag, {
    dir: direction
  }, children));
}

DirectionProvider.propTypes = {
  children: _propTypes.default.any.isRequired,
  dir: _propTypes.default.any,
  inline: _propTypes.default.bool,
  value: _propTypes.default.string
};