"use strict";

exports.__esModule = true;
exports.default = getFlushedStyles;

var _hasQueryCondition = _interopRequireDefault(require("./hasQueryCondition"));

var _toArray = _interopRequireDefault(require("./toArray"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getFlushedStyles(styles) {
  return (0, _toArray.default)(styles).reduce(function (css, style) {
    var sheet = style.sheet;
    var content = '';

    if (sheet && sheet.cssRules) {
      content = Array.from(sheet.cssRules).map(function (rule) {
        return rule ? rule.cssText : '';
      }).join('\n');
    } else if (style.textContent) {
      content = style.textContent;
    }

    if (!content) {
      return css;
    }

    if (style.media && (0, _hasQueryCondition.default)(style.media)) {
      content = "@media " + style.media + " { " + content + " }";
    }

    return (css + "\n" + content).trim();
  }, '');
}