import React from 'react';
import Aesthetic, { StyleSheetDefinition } from 'aesthetic';
import { WithStylesOptions, WithStylesWrappedProps, WithStylesWrapperProps, StyledComponentClass } from './types';
/**
 * Wrap a React component with an HOC that injects the defined style sheet as a prop.
 */
export default function withStylesFactory<Theme extends object, NativeBlock extends object, ParsedBlock extends object | string = NativeBlock>(aesthetic: Aesthetic<Theme, NativeBlock, ParsedBlock>): <T>(styleSheet: StyleSheetDefinition<Theme, T>, options?: WithStylesOptions) => <Props extends object = {}>(WrappedComponent: React.ComponentType<Props & WithStylesWrappedProps<Theme, NativeBlock, ParsedBlock>>) => StyledComponentClass<Theme, Props & WithStylesWrapperProps>;
//# sourceMappingURL=withStylesFactory.d.ts.map