"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var hoist_non_react_statics_1 = __importDefault(require("hoist-non-react-statics"));
var v4_1 = __importDefault(require("uuid/v4"));
var DirectionContext_1 = __importDefault(require("./DirectionContext"));
/**
 * Wrap a React component with an HOC that injects the defined style sheet as a prop.
 */
function withStylesFactory(aesthetic) {
    return function withStyles(styleSheet, options) {
        if (options === void 0) { options = {}; }
        var _a = options.cxPropName, cxPropName = _a === void 0 ? aesthetic.options.cxPropName : _a, _b = options.extendable, extendable = _b === void 0 ? aesthetic.options.extendable : _b, _c = options.extendFrom, extendFrom = _c === void 0 ? '' : _c, _d = options.passThemeProp, passThemeProp = _d === void 0 ? aesthetic.options.passThemeProp : _d, _e = options.pure, pure = _e === void 0 ? aesthetic.options.pure : _e, _f = options.stylesPropName, stylesPropName = _f === void 0 ? aesthetic.options.stylesPropName : _f, _g = options.themePropName, themePropName = _g === void 0 ? aesthetic.options.themePropName : _g;
        return function withStylesComposer(WrappedComponent) {
            var baseName = WrappedComponent.displayName || WrappedComponent.name;
            var styleName = baseName + "-" + v4_1.default();
            var Component = pure ? react_1.default.PureComponent : react_1.default.Component;
            aesthetic.registerStyleSheet(styleName, styleSheet, extendFrom);
            var WithStyles = /** @class */ (function (_super) {
                __extends(WithStyles, _super);
                // eslint-disable-next-line @typescript-eslint/member-ordering
                function WithStyles(props, dir) {
                    var _this = _super.call(this, props) || this;
                    _this.transformStyles = function () {
                        var styles = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            styles[_i] = arguments[_i];
                        }
                        return aesthetic.transformStyles(styles, _this.state.options);
                    };
                    var opts = {
                        name: styleName,
                        rtl: aesthetic.isRTL(dir),
                    };
                    _this.state = {
                        dir: dir,
                        options: opts,
                        styles: aesthetic.createStyleSheet(styleName, opts),
                    };
                    return _this;
                }
                WithStyles.extendStyles = function (customStyleSheet, extendOptions) {
                    if (extendOptions === void 0) { extendOptions = {}; }
                    if (__DEV__) {
                        if (!extendable) {
                            throw new Error(baseName + " is not extendable.");
                        }
                    }
                    return withStyles(customStyleSheet, __assign({}, options, extendOptions, { extendFrom: styleName }))(WrappedComponent);
                };
                WithStyles.prototype.componentDidMount = function () {
                    aesthetic.flushStyles(styleName);
                };
                WithStyles.prototype.componentDidUpdate = function () {
                    var dir = this.context;
                    if (dir !== this.state.dir) {
                        var opts = {
                            name: styleName,
                            rtl: aesthetic.isRTL(dir),
                        };
                        // eslint-disable-next-line react/no-did-update-set-state
                        this.setState({
                            dir: dir,
                            options: opts,
                            styles: aesthetic.createStyleSheet(styleName, opts),
                        }, function () {
                            aesthetic.flushStyles(styleName);
                        });
                    }
                };
                WithStyles.prototype.render = function () {
                    var _a;
                    var _b = this.props, wrappedRef = _b.wrappedRef, props = __rest(_b, ["wrappedRef"]);
                    var extraProps = (_a = {},
                        _a[cxPropName] = this.transformStyles,
                        _a[stylesPropName] = this.state.styles,
                        _a.ref = wrappedRef,
                        _a);
                    if (passThemeProp) {
                        extraProps[themePropName] = aesthetic.getTheme();
                    }
                    return react_1.default.createElement(WrappedComponent, __assign({}, props, extraProps));
                };
                WithStyles.contextType = DirectionContext_1.default;
                WithStyles.displayName = "withStyles(" + baseName + ")";
                WithStyles.styleName = styleName;
                WithStyles.WrappedComponent = WrappedComponent;
                return WithStyles;
            }(Component));
            hoist_non_react_statics_1.default(WithStyles, WrappedComponent);
            return WithStyles;
        };
    };
}
exports.default = withStylesFactory;
