import React from 'react';
import Aesthetic from 'aesthetic';
import { WithThemeOptions, WithThemeWrappedProps, WithThemeWrapperProps } from './types';
/**
 * Wrap a React component with an HOC that injects the current theme object as a prop.
 */
export default function withThemeFactory<Theme extends object, NativeBlock extends object, ParsedBlock extends object | string = NativeBlock>(aesthetic: Aesthetic<Theme, NativeBlock, ParsedBlock>): (options?: WithThemeOptions) => <Props extends object = {}>(WrappedComponent: React.ComponentType<Props & WithThemeWrappedProps<Theme>>) => React.ComponentClass<Props & WithThemeWrapperProps, any>;
//# sourceMappingURL=withThemeFactory.d.ts.map