"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var hoist_non_react_statics_1 = __importDefault(require("hoist-non-react-statics"));
/**
 * Wrap a React component with an HOC that injects the current theme object as a prop.
 */
function withThemeFactory(aesthetic) {
    return function withTheme(options) {
        if (options === void 0) { options = {}; }
        var _a = options.pure, pure = _a === void 0 ? aesthetic.options.pure : _a, _b = options.themePropName, themePropName = _b === void 0 ? aesthetic.options.themePropName : _b;
        return function withThemeComposer(WrappedComponent) {
            var baseName = WrappedComponent.displayName || WrappedComponent.name;
            var Component = pure ? react_1.default.PureComponent : react_1.default.Component;
            var WithTheme = /** @class */ (function (_super) {
                __extends(WithTheme, _super);
                function WithTheme() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                WithTheme.prototype.render = function () {
                    var _a;
                    var _b = this.props, wrappedRef = _b.wrappedRef, props = __rest(_b, ["wrappedRef"]);
                    var extraProps = (_a = {},
                        _a[themePropName] = aesthetic.getTheme(),
                        _a.ref = wrappedRef,
                        _a);
                    return react_1.default.createElement(WrappedComponent, __assign({}, props, extraProps));
                };
                WithTheme.displayName = "withTheme(" + baseName + ")";
                WithTheme.WrappedComponent = WrappedComponent;
                return WithTheme;
            }(Component));
            hoist_non_react_statics_1.default(WithTheme, WrappedComponent);
            return WithTheme;
        };
    };
}
exports.default = withThemeFactory;
